/*
 * BLE.c
 *
 *  Created on: Jan 29, 2018
 *      Author: Tomas
 */


#include "BLE.h"


BLEBeaconStatus getBeaconStatus() {
	BLEsetAutorunOn();
	BLEsetPowerOn();
	mDevice.last_ble_check = HAL_GetTick();


	BLEBeaconStatus ret = BEACON_OUT_OF_RANGE;
	if ( findMatchNonblocking( &huart2buffer, "+FOUND", strlen( "+FOUND" ), 11000 ) != -1 ) {
		ret = BEACON_IN_RANGE;
	}

	BLEsetPowerOff();
	BLEsetAutorunOff();

	return ret;
}

void BLEsetAutorunOn() {
	//HAL_GPIO_WritePin( AutoRUN_GPIO_Port, AutoRUN_Pin, GPIO_PIN_SET );
}

void BLEsetAutorunOff() {
	//HAL_GPIO_WritePin( AutoRUN_GPIO_Port, AutoRUN_Pin, GPIO_PIN_RESET );
}

void BLEsetPowerOn() {
	if ( mDevice.RADIO_STATUS == DEVICE_OFF && mDevice.GPS_STATUS == DEVICE_OFF ) {
		HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_SET);
	}
	mDevice.BLE_STATUS = DEVICE_ON;
	uart_type = UART_BLE;
	HAL_GPIO_WritePin( V_BLE_EN_GPIO_Port, V_BLE_EN_Pin, GPIO_PIN_RESET );
	HAL_Delay( 2000 );
	MX_USART2_UART_Init_BLE();
	//setUpTimeoutAlarm( 3000, 0 );
	while( HAL_UART_Receive_DMA( &huart2, uart2buffer, 2 ) != HAL_OK ) {
		/*
		if ( isRTCTimeout( 0 ) == 1 ) {
		  errorHandler( DMA_ERROR );
		}
		*/
	}

	HAL_GPIO_WritePin( V_BLE_EN_GPIO_Port, V_BLE_EN_Pin, GPIO_PIN_SET );




	uartRxBuffInit( &huart2buffer );

	HAL_Delay( 3000 );
}

void BLEsetPowerOff() {
	HAL_GPIO_WritePin( V_BLE_EN_GPIO_Port, V_BLE_EN_Pin, GPIO_PIN_RESET );

	if ( mDevice.RADIO_STATUS == DEVICE_OFF && mDevice.GPS_STATUS == DEVICE_OFF ) {
		HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_RESET);
	}
	HAL_UART_DeInit( &huart2 );

	mDevice.BLE_STATUS = DEVICE_OFF;

	//deInitLPUART1Pins();
}

