/*
 * L80.c
 *
 *  Created on: Aug 25, 2017
 *      Author: Tomas
 */
#include "L80.h"
extern char uart1buffer[ 2 ];
uartRxBuff_t huart1buffer;
void L80Reset() {

	HAL_GPIO_WritePin( V_GPS_EN_GPIO_Port, V_GPS_EN_Pin, GPIO_PIN_RESET );

	HAL_Delay( 2000 );

	HAL_GPIO_WritePin( V_GPS_EN_GPIO_Port, V_GPS_EN_Pin, GPIO_PIN_SET );

	HAL_Delay( 2000 );


}

void L80SetFixFrequency() {

	HAL_UART_Transmit( &huart1, "$PMTK220,10000*2F\r\n", strlen( "$PMTK220,10000*2F\r\n" ), 1000 );

}
uint16_t pos = 0;
char buffer[ 200 ];

GPSFixStatus checkIfFix(  uint8_t * lat, uint8_t * lon  ) {

	GPSFixStatus stat = NO_FIX;

	uint8_t comma_count = 0;
	uint16_t res = 0;
	uint8_t found_prependix = 0;

	uint8_t lat_buff_pos = 0;

	uint8_t lon_buff_pos = 0;

	for( int x = 0; x < 20; x++ ) {
		lat[ x ] = 0;
		lon[ x ] = 0;
	}





	while ( huart1buffer.start != huart1buffer.end ) {
		uint8_t g = uartRxBuffRead( &huart1buffer );
		buffer[ pos ] = g;
		pos++;
		if ( g == '\n' ) {
			buffer[ pos ] = 0;
				if ( strstr( buffer, "$GNGGA" ) != NULL ) {
					for( int x = 0; x < pos; x++ ) {
						if ( comma_count == 6 ) {
							if ( buffer[ x ]  == '1' ) {

								 res = 1;
								 comma_count = 6;
								 pos = 0;
								 return FIX;
							}else{
								res = 0;
								break;

							}
						}

						if ( comma_count == 2 && lat_buff_pos < 20 ) {
							if ( buffer[ x ] != '.' && buffer[ x ] != ',' ) {
								lat[ lat_buff_pos++ ] = buffer[ x ];
							}
						}

						if ( comma_count == 4 && lon_buff_pos < 20 ) {
							if ( buffer[ x ] != '.' && buffer[ x ] != ',' ) {
								lon[ lon_buff_pos++ ] = buffer[ x ];
							}

						}

						if ( buffer[ x ] == ',' ) {
							comma_count++;
						}

					}
					comma_count = 0;
					lat_buff_pos = 0;
					lon_buff_pos = 0;
				}
				pos = 0;
		}


	}
	if (res == 1) {
		stat = FIX;
	}


	return stat;
}

void disableFIXPin() {

	  GPIO_InitTypeDef GPIO_InitStruct;

	  GPIO_InitStruct.Pin = FIX_Pin;
	  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING;
	  GPIO_InitStruct.Pull = GPIO_NOPULL;
	  HAL_GPIO_Init(FIX_GPIO_Port, &GPIO_InitStruct);

}


void enableFIXPin() {

	  GPIO_InitTypeDef GPIO_InitStruct;

	  GPIO_InitStruct.Pin = FIX_Pin;
	  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	  GPIO_InitStruct.Pull = GPIO_NOPULL;
	  HAL_GPIO_Init(FIX_GPIO_Port, &GPIO_InitStruct);

}

void L80Enable() {
	MX_DMA_Init();
	if ( mDevice.RADIO_STATUS == DEVICE_OFF && mDevice.BLE_STATUS == DEVICE_OFF ) {
		HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_SET);
	}

	mDevice.GPS_STATUS = DEVICE_ON;

	HAL_Delay( 500 );
	HAL_GPIO_WritePin( V_BKP_GPIO_Port, V_BKP_Pin, GPIO_PIN_SET );
	HAL_Delay( 500 );
	HAL_GPIO_WritePin( V_GPS_EN_GPIO_Port, V_GPS_EN_Pin, GPIO_PIN_SET );
	HAL_Delay( 500 );
	uartRxBuffInit( &huart1buffer );
	MX_USART1_UART_Init();
	while( HAL_UART_Receive_DMA(&huart1, uart1buffer, 2 ) != HAL_OK ){
		continue;
	}

	L80Reset();

	for( int x = 0; x < 5; x++ ) {
		L80SetFixFrequency();
		HAL_Delay( 500 );
	}
	//L80SetFixFrequency();
}

void L80Disable() {
	if ( mDevice.RADIO_STATUS == DEVICE_OFF && mDevice.BLE_STATUS == DEVICE_OFF ) {
		HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_RESET);
	}

	mDevice.GPS_STATUS = DEVICE_OFF;
	HAL_GPIO_WritePin( V_GPS_EN_GPIO_Port, V_GPS_EN_Pin, GPIO_PIN_RESET );
	HAL_UART_DeInit( &huart1 );
	//deInitUART1Pins();
	//disableFIXPin();
}

void L80StartAlwaysLocateMode() {

	HAL_UART_Transmit( &huart1, "$PMTK225,8*23\r\n", strlen( "$PMTK225,8*23\r\n" ), 1000 );

}


void L80SendColdStart() {

	HAL_UART_Transmit( &huart1, "$PMTK103*30\r\n", strlen( "$PMTK103*30\r\n" ), 1000 );

}

void L80EnableGPSBackupClock() {
	//HAL_GPIO_WritePin( Rezerva1, GPIO_PIN_SET );
}

void L80DisableGPSBackupClock() {
	//HAL_GPIO_WritePin( Rezerva1, GPIO_PIN_SET );
}


void L80Check() {

	L80Enable();
	L80Reset();
	L80EnableGPSBackupClock();

	HAL_Delay( 3000 );
	char buffer[ 80 ];
	uint8_t pos = 0;

	uint32_t time_receive = 0;
/*
	if ( HAL_UART_Transmit( dev->huart, "$PMTK605*31\r\n", strlen( "$PMTK605*31\r\n" ), 1000 ) ) {

	}
*/
	time_receive = HAL_GetTick();

	buffer[ 0 ] = 0;
	int32_t found = -1;
	while( found == -1 && time_receive + 10000 >  HAL_GetTick() ) {
		  //default boot up msg
		 found = findMatchNonblocking( &huart1buffer, "$PMTK", 5, 1000 );
		 //maybe we missed boot so try periodic msg
		 found = findMatchNonblocking( &huart1buffer, "$GPGSA", 5, 1000 );
/*
		if ( HAL_UART_Receive( dev->huart, buffer, 1, 1000 ) == HAL_OK ) {
			pos++;
		}
*/
	}

	L80Disable();

}
