/*
 * L80.h
 *
 *  Created on: Aug 25, 2017
 *      Author: Tomas
 */

#ifndef L80_H_
#define L80_H_


#include "main.h"
#include "stdint.h"
#include "gpio.h"
#include "usart.h"
#include "uartRxBuff.h"
#include "led.h"

struct GPSPoint {
	int32_t lattitude;
	char lattitude_dir;
	int32_t longitude;
	char longitude_dir;

};

typedef struct GPSPoint GPSPoint;
extern MainDevice mDevice;
typedef enum GPSFixStatus {
	FIX = 1, NO_FIX = 0
}GPSFixStatus;

struct L80Data {
	uint8_t msg_id;
	uint32_t timestamp;
	char utc_time[40];
	uint8_t valid;
	char lat[40];
	uint8_t direction_s_n;
	char log[40];
	uint8_t direction_e_w;
	uint8_t speed;
	uint8_t cog;
	uint8_t data;
	uint8_t magnetic_var;
	uint8_t magnetic_direction_e_w;
	uint8_t positioning_status;

};

void L80Check();
void L80Enable();
void L80Disable();
void L80SendColdStart();
void L80StartAlwaysLocateMode();
void L80EnableGPSBackupClock();
void L80DisableGPSBackupClock();
void L80SetFixFrequency();

GPSFixStatus checkIfFix( uint8_t * lat, uint8_t * lon  );


#endif /* L80_H_ */
