/*
 * murata.c
 *
 *  Created on: Aug 18, 2017
 *      Author: fiala
 */

#include "lora.h"


void lora_UART_Init(void)
{
	MX_DMA_Init();

	MX_USART2_UART_Init1( 19200 );
	uartRxBuffInit( &huart2buffer  );
	while( HAL_UART_Receive_DMA(&huart2, uart2buffer, 2 ) != HAL_OK)
		HAL_UART_Transmit( &huart2, "DMA buff not set!\n" , strlen("DMA buff not set!\n"), 1000);

}

void dataToHex(char * out_string, uint8_t data)
{
	char conv[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

	out_string[1] = conv[ (data & 0b00001111) ];
	out_string[0] = conv[ (data & 0b11110000) >> 4 ];
}
uint8_t lora_recv_msg() {
/*
	char msg_radio[14] = "\rAT+UTX 1\r62\r\0";


	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	HAL_UART_Transmit( &huart2, msg_radio, strlen( msg_radio ), DEFAULT_UART_TIMEOUT );
	uartRxBuffClear();
	*/
	//magneticDelay( 40000 );

	if ( findMatchNonblocking( &huart2buffer, "+RECV=", 6, 4000 ) != -1 ) {
		HAL_Delay( 1000 );
		uint8_t ff[ 30 ];
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );
		uartRxBuffRead( &huart2buffer );

		char buf[ 3 ];

		buf[ 0 ] = uartRxBuffRead( &huart2buffer );
		buf[ 1 ] = uartRxBuffRead( &huart2buffer );
		buf[ 2 ] = 0;
		char * buff;

		uint8_t res = strtol( buf, &buff, 16 );

		if ( res == 1 ) {
			ALARM_STATUS = ALARM;
		}else{
			ALARM_STATUS = NO_ALARM;

		}



	}


	return NO_COMMANDS;
}



void lora_on( void )
{
	lora_UART_Init();

	if ( mDevice.BLE_STATUS == DEVICE_OFF && mDevice.GPS_STATUS == DEVICE_OFF ) {
		HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_SET);
	}
	HAL_GPIO_WritePin( V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_SET);
	mDevice.RADIO_STATUS == DEVICE_ON;
	//	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );

	uartRxBuffInit( &huart2buffer );
	findMatchNonblocking(&huart2buffer , "EVENT", 5, 5000);

}

void lora_off( void )
{
	if ( mDevice.BLE_STATUS == DEVICE_OFF && mDevice.GPS_STATUS == DEVICE_OFF ) {
		HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_RESET);
	}
	HAL_GPIO_WritePin( V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_RESET);
//	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );
	HAL_UART_DeInit(&huart2);

	  GPIO_InitTypeDef GPIO_InitStruct;
	  GPIO_InitStruct.Pin = RX_RADIO_Pin | TX_RADIO_Pin;
	  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	  GPIO_InitStruct.Pull = GPIO_NOPULL;
	  HAL_GPIO_Init( RX_RADIO_GPIO_Port , &GPIO_InitStruct);
		mDevice.RADIO_STATUS == DEVICE_ON;
}


void lora_init(void)
{


	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	lora_on();

	//HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);

	HAL_UART_Transmit(&huart2, "AT+FACNEW\r", strlen("AT+FACNEW\r"), 500);
	HAL_Delay(5000);
	HAL_UART_Transmit(&huart2, "AT+CLASS=0\r", strlen("AT+CLASS=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DFORMAT=1\r", strlen("AT+DFORMAT=1\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+ADR=0\r", strlen("AT+ADR=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DR=0\r", strlen("AT+DR=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+BAND=5\r", strlen("AT+BAND=5\r"), 500);

	HAL_Delay(500);
//#define OTA
#define ABP
#ifdef OTA
	HAL_UART_Transmit(&huart2, "AT+MODE=1\r", strlen("AT+MODE=1\r"), 500);
#endif
#ifdef ABP
	HAL_UART_Transmit(&huart2, "AT+MODE=0\r", strlen("AT+MODE=0\r"), 500);
#endif
	HAL_Delay(500);
//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//20dBm
//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=0,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//16dBm
	HAL_UART_Transmit(&huart2, "AT+MAXEIRP=20\r", strlen("AT+MAXEIRP=20\r"), 500);
	HAL_Delay(500);

	HAL_UART_Transmit(&huart2, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500);	//14dBm

	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DUTYCYCLE=0\r", strlen("AT+DUTYCYCLE=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+SLEEP=0\r", strlen("AT+SLEEP=0\r"), 500);
	/*
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=3,867100000,0,5\r", strlen("AT+RFPARAM=3,867100000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=4,867300000,0,5\r", strlen("AT+RFPARAM=4,867300000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=5,867500000,0,5\r", strlen("AT+RFPARAM=5,867500000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=6,867700000,0,5\r", strlen("AT+RFPARAM=6,867700000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=7,867900000,0,5\r", strlen("AT+RFPARAM=7,867900000,0,5\r"), 500);
	HAL_Delay(500);

	HAL_UART_Transmit( &huart2, "AT+NWKSKEY?\r" , strlen("AT+NWKSKEY?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPSKEY?\r" , strlen("AT+APPSKEY?\r"), 1000);
	HAL_Delay(500);
	*/
	HAL_UART_Transmit( &huart2, "AT+NWKSKEY=9087654321AFBECD5647382910DACFEB\r" , strlen("AT+NWKSKEY=9087654321AFBECD5647382910DACFEB\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPSKEY=1029384756AFBECD5647382910DACFEB\r" , strlen("AT+APPSKEY=1029384756AFBECD5647382910DACFEB\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+DEVADDR?\r" , strlen("AT+DEVADDR?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+DEVEUI?\r" , strlen("AT+DEVEUI?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPEUI?\r" , strlen("AT+APPEUI?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPKEY?\r" , strlen("AT+APPKEY?\r"), 1000);
	HAL_Delay(500);
	lora_off();
}

void lora_send( char * command ) {
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	uartRxBuffInit( &huart2buffer );

	HAL_UART_Transmit( &huart2, command, strlen( command ), DEFAULT_UART_TIMEOUT );
	HAL_Delay( 3500 );
	lora_recv_msg();
}

void radio_send_multibyte_msg( char * buffer, int len ) {

	#ifdef MURATA
		char msg_radio[200];

		sprintf( msg_radio, "\rAT+UTX %d\r%s\r", len, buffer );
		lora_on();
		lora_send( msg_radio );
		lora_off();
		//HAL_UART_Transmit( &huart2, "\r", 1, 20 );
		//HAL_UART_Transmit( &huart2, msg_radio, 13, DEFAULT_UART_TIMEOUT );
		// toto nie je finalne riesenie, treba prepracovat!!!!
	#endif
	#ifdef SIGFOX
		char msg_radio[40] = "\rAT$SF=";
		memcpy(msg_radio+7, buffer, len*2);
		msg_radio[ 7 + len*2 ] = '\r';
		msg_radio[ 7 + len*2 + 1 ] = 0;

		sigfox_send( msg_radio );
		//HAL_UART_Transmit( &huart2, "\r", 1, 20 );
		//HAL_UART_Transmit( &huart2, msg_radio, 13, DEFAULT_UART_TIMEOUT );
			// toto nie je finalne riesenie, treba prepracovat!!!!
	#endif
}


void lora_join_network() {

	//HAL_GPIO_WritePin(RM_EN_GPIO_Port, RM_EN_Pin, GPIO_PIN_SET);
	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	//HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
	//HAL_Delay(10000); //wait for power up radio
	//HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_SET);

	lora_on();

	uartRxBuffClear( &huart2buffer );
	//while(1)
	HAL_UART_Transmit(&huart2, "\rAT+JOIN\r", strlen("\rAT+JOIN\r"), 100 );
	uint64_t start = HAL_GetTick();
	while( ( start + 400000 ) > HAL_GetTick() )
	{
		if(findMatchNonblocking(&huart2buffer , "EVENT=1,1", 9, 5000) == 1)
		{
			break;
		}
		if(findMatchNonblocking(&huart2buffer , "EVENT=1,0", 9, 500) == 1)
		{
			uartRxBuffClear();
			HAL_UART_Transmit(&huart2, "AT+JOIN\r", strlen("AT+JOIN\r"), 100 );
		}
		blinkLed( LED1, 100 );
	}
/*
	HAL_GPIO_WritePin(RM_EN_GPIO_Port, RM_EN_Pin, GPIO_PIN_RESET);
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );
*/
	//murata_send_periodic_data( "0F" );

	lora_off();
}
/*
void murata_send_periodic_data_p( char * data, uint8_t power )
{

	char msg_radio[13] = "\rAT+UTX 1\rxx\r";
	memcpy(msg_radio+10, data, 2);
	murata_send_p( msg_radio, 13, power );

}


void murata_send_periodic_data( char * data )
{

	char msg_radio[13] = "\rAT+UTX 1\rxx\r";
	memcpy(msg_radio+10, data, 2);
	murata_send( msg_radio, 13 );

}

void murata_send_n_bytes( char * data , uint8_t n)
{
	char msg_radio[22] = "AT+UTX 1\rxx\r";
	memcpy(msg_radio+9, data, n);
	memcpy(msg_radio+9+n, "\r", 1);
	murata_send( msg_radio, 10 + n );
}
*/
/*
AT+REBOOT
AT+FACNEW

//AT+CLASS A

AT+MODE=1

AT+JOIN // raz pri prechode do operational modu
AT+CTX// raz za den sprava s ACK, ak nepride ACK -> join

AT+DUTYCYCLE

AT+SLEEP

AT+PORT

AT+REP

AT+DFORMAT

AT+UTX  // poslanie spravy bez ack

*/
