/*
 * init.c
 *
 *  Created on: Nov 24, 2016
 *      Author: Tomas
 */

#include "memory.h"

extern UART_HandleTypeDef huart2;


uint8_t readFromMem( uint64_t Address ) {

	return 	(*(__IO uint8_t *)Address);

}


FlashWriteStatus readModeFromFlash( uint8_t * res ) {
	uint8_t check = 0;
	uint8_t val = readFromMem( FLASH_USER_START_ADDR );
	if ( val == 0x80 ) {
		check++;
	}

	val = readFromMem( FLASH_USER_START_ADDR + 4 );

	if ( val == 0x8F ) {
		check++;
	}

	if ( check != 2 ) {
		return FLASH_ERROR;
	}
	(*res) = readFromMem( FLASH_USER_START_ADDR + 8 );
	return FLASH_OK;
	//HAL_FLASH_Lock();
}

FlashWriteStatus writeDeviceStateToFlash( PetTrackerModes mode ) {

	uint64_t start_time = HAL_GetTick();
	while ( HAL_FLASH_Unlock() != HAL_OK ) {
			if ( HAL_GetTick() - start_time > 4000 ) {
				return FLASH_ERROR;
			}
			continue;
	}

	static FLASH_EraseInitTypeDef EraseInitStruct;
	EraseInitStruct.TypeErase = FLASH_TYPEERASE_PAGES;
	EraseInitStruct.PageAddress = FLASH_USER_START_ADDR;
	EraseInitStruct.NbPages = 1;
	uint32_t ff;

	if ( HAL_FLASHEx_Erase(&EraseInitStruct, &ff) != HAL_OK){
		return FLASH_ERROR;
	}


	if ( HAL_FLASH_Program(FLASH_TYPEPROGRAM_WORD, FLASH_USER_START_ADDR, 0x80) != HAL_OK ) {
		return FLASH_ERROR;
	}

	if ( HAL_FLASH_Program(FLASH_TYPEPROGRAM_WORD, FLASH_USER_START_ADDR+4, 0x8F) != HAL_OK ) {
		return FLASH_ERROR;
	}

	uint32_t datas = mode;

	if ( HAL_FLASH_Program(FLASH_TYPEPROGRAM_WORD, FLASH_USER_START_ADDR+8, datas) != HAL_OK ) {
		return FLASH_ERROR;
	}

	HAL_FLASH_Lock();
	return FLASH_OK;


}

void writeAlarmsToFlash() {
	/*
	while ( HAL_FLASH_Unlock() != HAL_OK ) {
		continue;
	}
	static FLASH_EraseInitTypeDef EraseInitStruct;
	EraseInitStruct.TypeErase = FLASH_TYPEERASE_PAGES;
	EraseInitStruct.PageAddress = FLASH_USER_START_ADDR;
	EraseInitStruct.NbPages = (FLASH_USER_END_ADDR - FLASH_USER_START_ADDR) / FLASH_PAGE_SIZE;
	uint32_t ff;
		HAL_FLASHEx_Erase(&EraseInitStruct, &ff);

	uint32_t Address = FLASH_USER_START_ADDR;
	uint16_t data32 = MAX_NUMBER_OF_SENSORS;
	writeToMem(FLASH_TYPEPROGRAM_HALFWORD, Address, data32);


	HAL_FLASH_Lock();
	*/
}

void readAlarmsFromFlash( ) {
	uint32_t Address = FLASH_USER_START_ADDR;
	uint16_t data32;
/*
	for( int x = 0; x < MAX_NUMBER_OF_SENSORS; x++ ) {
		Address = Address + 2;
		data32 = *(__IO uint16_t *)Address;

		if ( data32 == 1 ) {

			//sensors[ x ].set_alarm.active = 1;
			Address = Address + 2;
			data32 = *(__IO uint16_t *)Address;

			sensors[ x ].set_alarm.highhigh = data32;

			Address = Address + 2;
			data32 = *(__IO uint16_t *)Address;

			sensors[ x ].set_alarm.high = data32;

			Address = Address + 2;
			data32 = *(__IO uint16_t *)Address;

			sensors[ x ].set_alarm.low = data32;

			Address = Address + 2;
			data32 = *(__IO uint16_t *)Address;

			sensors[ x ].set_alarm.lowlow = data32;

		}else{
			Address = Address + 8;
		}
	}
*/

}
