/*
 * murata.c
 *
 *  Created on: Aug 18, 2017
 *      Author: fiala
 */

#include "murata.h"
extern UART_HandleTypeDef huart_radio;


void murata_on( void )
{
	//UART_Init();
	MX_USART2_UART_Init1( 19200 );
	uartRxBuffInit( &huart2buffer );
	HAL_GPIO_WritePin(V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_SET);
	HAL_GPIO_WritePin( VSEL_GPIO_Port, VSEL_Pin, GPIO_PIN_SET );


    setUpTimeoutAlarm( 3000, 0 );
	while( HAL_UART_Receive_DMA( &huart2, uart2buffer, 2 ) != HAL_OK ) {
	  if ( isRTCTimeout( 0 ) == 1 ) {
		  //errorHandler( DMA_ERROR );
	  }
	}

	//uartRxBuffClear();
	if ( findMatchNonblocking( &huart2buffer, "EVENT", 5, 5000) != -1 ) {
		asm( "nop" );
	}else{
		//errorHandler( RADIO_ERROR );
	}

//	if( 1 == findMatchNonblocking("EVENT", 5, 5000) )
//		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
//	else
//		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_SET);

//		HAL_Delay(150); //wait for power up radio

}
/*
void murata_off( void )
{
	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );
#ifndef DEBUG_UART
	HAL_GPIO_WritePin(RM_EN_GPIO_Port, RM_EN_Pin, GPIO_PIN_RESET);
	HAL_UART_DeInit(&huart_radio);

	  GPIO_InitTypeDef GPIO_InitStruct;
	  GPIO_InitStruct.Pin = MCU_RX_Pin | MCU_TX_Pin;
	  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING;
	  GPIO_InitStruct.Pull = GPIO_NOPULL;
	  HAL_GPIO_Init(MCU_RX_GPIO_Port, &GPIO_InitStruct);
#endif

	HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );

	uartRxBuffClear();
	findMatchNonblocking("EVENT", 5, 5000);
//	if( 1 == findMatchNonblocking("EVENT", 5, 5000) )
//		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
//	else
//		HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_SET);

//		HAL_Delay(150); //wait for power up radio

}
*/
void murata_off( void )
{
	HAL_GPIO_WritePin(V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_RESET);
	HAL_UART_DeInit(&huart2);
	  GPIO_InitTypeDef GPIO_InitStruct;
	  GPIO_InitStruct.Pin = RX_RADIO_Pin | TX_RADIO_Pin;
	  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	  GPIO_InitStruct.Pull = GPIO_NOPULL;
	  HAL_GPIO_Init(TX_RADIO_GPIO_Port, &GPIO_InitStruct);

}

void murata_send( char * str, uint8_t len ) {
	//main_loop.batt_voltage_old = batt_measure();
	HAL_UART_Transmit( &huart2, "\r", 1, 20 );
	HAL_UART_Transmit( &huart2, str, len, DEFAULT_UART_TIMEOUT );
	//HAL_Delay( DEFAULT_UART_COMMAND_TIMEOUT );
	//batt_measure_periodic_IT_start();
	HAL_Delay( 4000 );	// toto nie je finalne riesenie, treba prepracovat!!!!

}

void murate_send_bytes( char * str, uint8_t len ) {
	radio_on();
	murata_just_send( str, len );
	radio_off();
}

void murata_just_send( char * str, uint8_t len )
{

	char msg_radio[13] = "\rAT+UTX 1\rxx\r";
	memcpy(msg_radio+10, str, len);
	memcpy(msg_radio+10+len, "\r", 1);
	murata_send( msg_radio, 10 + len + 1 );

}


void murata_init(void)
{



	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	murata_on();

	//HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "\r", strlen("\r"), 500);

	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+CLASS=0\r", strlen("AT+CLASS=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DFORMAT=1\r", strlen("AT+DFORMAT=1\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+ADR=0\r", strlen("AT+ADR=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DR=0\r", strlen("AT+DR=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+BAND=5\r", strlen("AT+BAND=5\r"), 500);

	HAL_Delay(500);
#define OTA
//#define ABP
#ifdef OTA
	HAL_UART_Transmit(&huart2, "AT+MODE=1\r", strlen("AT+MODE=1\r"), 500);
#endif
#ifdef ABP
	HAL_UART_Transmit(&huart2, "AT+MODE=0\r", strlen("AT+MODE=0\r"), 500);
#endif
	HAL_Delay(500);
//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//20dBm
//	HAL_UART_Transmit(&huart_radio, "AT+RFPOWER=0,0\r", strlen("AT+RFPOWER=1,0\r"), 500); 	//16dBm
	HAL_UART_Transmit(&huart2, "AT+MAXEIRP=20\r", strlen("AT+MAXEIRP=20\r"), 500);
	HAL_Delay(500);

	HAL_UART_Transmit(&huart2, "AT+RFPOWER=1,0\r", strlen("AT+RFPOWER=1,0\r"), 500);	//14dBm

	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+DUTYCYCLE=0\r", strlen("AT+DUTYCYCLE=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+SLEEP=0\r", strlen("AT+SLEEP=0\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=3,867100000,0,5\r", strlen("AT+RFPARAM=3,867100000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=4,867300000,0,5\r", strlen("AT+RFPARAM=4,867300000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=5,867500000,0,5\r", strlen("AT+RFPARAM=5,867500000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=6,867700000,0,5\r", strlen("AT+RFPARAM=6,867700000,0,5\r"), 500);
	HAL_Delay(500);
	HAL_UART_Transmit(&huart2, "AT+RFPARAM=7,867900000,0,5\r", strlen("AT+RFPARAM=7,867900000,0,5\r"), 500);
	HAL_Delay(500);

	HAL_UART_Transmit( &huart2, "AT+DEVEUI?\r" , strlen("AT+DEVEUI?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPEUI?\r" , strlen("AT+APPEUI?\r"), 1000);
	HAL_Delay(500);
	HAL_UART_Transmit( &huart2, "AT+APPKEY?\r" , strlen("AT+APPKEY?\r"), 1000);
	HAL_Delay(500);
	murata_off();
}

void murata_join_network() {
	murata_on();
	//HAL_GPIO_WritePin(RM_EN_GPIO_Port, RM_EN_Pin, GPIO_PIN_SET);
	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_SET );
	//HAL_GPIO_WritePin(LED_GPIO_Port, LED_Pin, GPIO_PIN_RESET);
	HAL_Delay(10000); //wait for power up radio
	//HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_SET);

	HAL_UART_Transmit(&huart2, "AT+JOIN\r", strlen("AT+JOIN\r"), 100 );

	uint64_t start_time = HAL_GetTick();
	uartRxBuffInit( &huart2buffer );
	while( 1 )
	{
		if(findMatchNonblocking(&huart2buffer, "EVENT=1,1", 9, 500) != -1)
		{
			break;
		}

		if(findMatchNonblocking(&huart2buffer, "EVENT=1,0", 9, 500 ) != -1 || ( start_time + 120000 ) < HAL_GetTick() )
		{
			asm( "nop" );
			start_time = HAL_GetTick();
			HAL_UART_Transmit(&huart2, "AT+JOIN\r", strlen("AT+JOIN\r"), 100 );
			uartRxBuffInit( &huart2buffer );
		}

		//HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_RESET);
		//HAL_Delay(25);
		//HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_SET);
	}

	HAL_GPIO_WritePin( V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_RESET );
	//HAL_GPIO_WritePin( NRST_RADIO_GPIO_Port, NRST_RADIO_Pin, GPIO_PIN_RESET );

	murata_send_periodic_data( "0F" );
	murata_off();

}

void murata_send_periodic_data( char * data )
{

	char msg_radio[13] = "\rAT+UTX 1\rxx\r";
	memcpy(msg_radio+10, data, 2);
	murata_send( msg_radio, 13 );

}

void murata_send_n_bytes( char * data , uint8_t n)
{
	char msg_radio[22] = "AT+UTX 1\rxx\r";
	memcpy(msg_radio+9, data, n);
	memcpy(msg_radio+9+n, "\r", 1);
	murata_send( msg_radio, 10 + n );
}

/*
AT+REBOOT
AT+FACNEW

//AT+CLASS A

AT+MODE=1

AT+JOIN // raz pri prechode do operational modu
AT+CTX// raz za den sprava s ACK, ak nepride ACK -> join

AT+DUTYCYCLE

AT+SLEEP

AT+PORT

AT+REP

AT+DFORMAT

AT+UTX  // poslanie spravy bez ack

*/
