/*
 * radio.h
 *
 *  Created on: Aug 22, 2017
 *      Author: pc
 */

#ifndef RADIO_H_
#define RADIO_H_

#include "main.h"
#include "usart.h"

#ifdef SIGFOX
#include "sigfox.h"
#endif

#ifdef MURATA
#include "lora.h"
#endif


#define CAN_SEND 0
#define CANT_SEND 1
#define LAST_SEND 2

extern MainDevice mDevice;

#define POWER_20 0
#define POWER_17 1
#define POWER_16 1
#define POWER_15 1
#define POWER_14 2

//uint16_t frame_counter = 0;

void radio_init(void);
void radio_set_power( uint8_t power );
void radio_send_msg( char * hex );
void radio_on();
void radio_off();
uint8_t radio_recv_msg();
void radio_send_system_error( uint8_t acc_err, uint8_t gps_failed_fix, uint8_t gps_global_fail, uint8_t ble_fail  );
#endif /* RADIO_H_ */
