/*
 * sigfox.c
 *
 *  Created on: Mar 9, 2018
 *      Author: Tomas
 */
#include "sigfox.h"

void sigfox_UART_Init(void)
{
	/*
	MX_DMA_Init();

	HAL_NVIC_SetPriority(DMA1_Channel4_5_6_7_IRQn, 0, 0);
	HAL_NVIC_EnableIRQ(DMA1_Channel4_5_6_7_IRQn);
	*/

	MX_USART2_UART_Init1( 9600 );
	uartRxBuffInit( &huart2buffer );
	while( HAL_UART_Receive_DMA(&huart2, uart2buffer, 2 ) != HAL_OK)
		HAL_UART_Transmit( &huart2, "DMA buff not set!\n" , strlen("DMA buff not set!\n"), 1000);

}

void sigfox_on( void )
{
	sigfox_UART_Init();

	uartRxBuffInit( &huart2buffer );
	HAL_GPIO_WritePin( V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_SET );

	findMatchNonblocking( &huart2buffer, "SIGFOX", 6, 8000 );

}

void sigfox_send( char * command ) {
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	HAL_UART_Transmit( &huart2, command, strlen( command ), DEFAULT_UART_TIMEOUT );
	findMatchNonblocking(&huart2buffer, "OK", 5, 8000);

}
void sigfox_get_provisioning() {
	HAL_UART_Transmit( &huart2, "AT$ID\r" , strlen("AT$ID\r"), 1000);
	HAL_Delay( 150 );
	HAL_UART_Transmit( &huart2, "AT$PAC\r" , strlen("AT$PAC\r"), 1000);
	HAL_Delay( 150 );


}

uint16_t sigfox_frame_counter1 = 0;

uint8_t sigfox_frame_counter() {
	if ( sigfox_frame_counter1 < 139 ) {
		sigfox_frame_counter1++;
	}
}

uint8_t sigfox_recv_msg() {
	uint8_t v = 0;
	sigfox_on();
	char msg_radio[14] = "\rAT$SF=xx,1\r\0";
	memcpy(msg_radio+7, "04", 2);
	HAL_UART_Transmit( &huart2, "\r", 1, DEFAULT_UART_TIMEOUT );
	HAL_Delay( 25 );
	uartRxBuffInit( &huart2buffer );
	HAL_UART_Transmit( &huart2, msg_radio, strlen( msg_radio ), DEFAULT_UART_TIMEOUT );
	if ( findMatchNonblocking( &huart2buffer, "+RX", 5, 60000) == 0 ) {
		return 0;
	}else{
		char val_buffer[ 15 ];
		findMatchAndValueBlocking( &huart2buffer, "=", 1, &val_buffer, 1, 12, 0 );
		return val_buffer[ 0 ];
	}
	sigfox_off();
	//HAL_UART_Transmit( &huart2, "AT$PAC\r" , strlen("AT$PAC\r"), 1000);

}

void sigfox_init() {

	sigfox_on();
	HAL_UART_Transmit( &huart2, "\r" , strlen("\r"), 1000);
	HAL_Delay( 25 );
	//HAL_UART_Transmit( &huart2, "\r" , strlen("\r"), 1000);
	sigfox_get_provisioning();
	sigfox_off();


}

void sigfox_off( void )
{
	HAL_GPIO_WritePin( V_RADIO_EN_GPIO_Port, V_RADIO_EN_Pin, GPIO_PIN_RESET);
	//HAL_GPIO_WritePin( RM_NRST_GPIO_Port, RM_NRST_Pin, GPIO_PIN_RESET );
	HAL_UART_DeInit(&huart2);

	  GPIO_InitTypeDef GPIO_InitStruct;
	  GPIO_InitStruct.Pin = TX_RADIO_Pin | RX_RADIO_Pin;
	  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
	  GPIO_InitStruct.Pull = GPIO_NOPULL;
	  HAL_GPIO_Init(RX_RADIO_GPIO_Port, &GPIO_InitStruct);

}
