/*
 * buff->c
 *
 *  Created on: May 25, 2017
 *      Author: fiala
 */
#include "uartRxbuff.h"





void uartRxBuffInit(uartRxBuff_t * buff)
{
	buff->end = 0;
	buff->start = 0;
}
void uartRxBuffWrite(uartRxBuff_t * buff, uint8_t data)
{
	buff->data[buff->end] = data;
	buff->end += 1;
	buff->end = buff->end % UART_RX_BUFF_SIZE;
}
uint8_t uartRxBuffRead(uartRxBuff_t * buff)
{
	uint8_t data = buff->data[buff->start];
	buff->start += 1;
	buff->start = buff->start % UART_RX_BUFF_SIZE;
	return data;
}
uint8_t * uartRxBuffGetStart(uartRxBuff_t * buff)
{
	return &buff->data[buff->start];
}

uint8_t uartRxBuffGetUsedSize(uartRxBuff_t * buff)
{	if(buff->end >= buff->start)
		return( buff->end - buff->start );
	else
		return( UART_RX_BUFF_SIZE - buff->end + buff->start);
}

int32_t compareResponse(uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, uint8_t * compare, uint8_t cmp_len, uint8_t * match_position )
{
	//HAL_UART_Transmit( &huart2, expect ,  exp_len, 1000);
	//HAL_UART_Transmit( &huart2, "\n" , 1, 1000);

	uint8_t equal = 0;
	if(exp_len > cmp_len)
	{
		//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
		return -1;
	}
	uint8_t i;
	for(i = 0; i < cmp_len; i++)
	{
		if(expect[0] == compare[ i % UART_RX_BUFF_SIZE ] || expect[0] == '*' ) //character matches with first character of expectation
		{
			if( cmp_len-i < exp_len) //compared is shorter than expected
			{
				//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
				return -1;
			}
			equal = 1;
			uint8_t j;
			for(j = 0; j < exp_len; j++)
			{
				if(expect[j] != compare[ (j+i) % UART_RX_BUFF_SIZE ] && expect[j] != '*' ) //compare other chatacters
				{
					equal = 0;
					break;
				}
			}
			if(equal == 1)
			{
				match_position = i;
				//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
				return i;
			}
		}
	}
	//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
	match_position = 0;
	return -1;
}

int32_t copyFromBuffer( uartRxBuff_t * buff, uint8_t size, int32_t position, uint8_t * output) {
	uint8_t pos = 0;
	uint8_t size_test = 0, go = 1;
	char * test_string;

	for ( int x = 0; x < 90; x++ ) {
		if ( buff->data[ x ] == '$' ) {
			if ( buff->data[ x + 1 ] == 'G' ) {
				if ( buff->data[ x + 2 ] == 'P' ) {
					if ( buff->data[ x + 3 ] == 'G' ) {
						if ( buff->data[ x + 4 ] == 'G' ) {
							if ( buff->data[ x + 5 ] == 'A' ) {
								if ( buff->data[ x + 5 ] == 'A' ) {
									if ( buff->data[ x + 5 ] == 'A' ) {
										if ( buff->data[ x + 5 ] == 'A' ) {
											//position = x;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	memcpy( output, buff->data + position, size );
	/*
	while( pos < size  ) {
		output[ pos ] = buff->data[ position ];
	    position = ( position + pos ) % UART_RX_BUFF_SIZE;
	    pos++;
	}
*/
	return position;
}

int32_t compareResponseWild(uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, uint8_t * compare, uint8_t cmp_len, uint8_t * match_position )
{
	//HAL_UART_Transmit( &huart2, expect ,  exp_len, 1000);
	//HAL_UART_Transmit( &huart2, "\n" , 1, 1000);

	uint8_t equal = 0;
	if(exp_len > cmp_len)
	{
		//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
		return -1;
	}
	uint8_t i;
	for(i = 0; i < cmp_len; i++)
	{
		if(expect[0] == compare[ i % UART_RX_BUFF_SIZE ] || expect[0] == '*' ) //character matches with first character of expectation
		{
			if( cmp_len-i < exp_len) //compared is shorter than expected
			{
				//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
				return -1;
			}
			equal = 1;
			uint8_t j;
			for(j = 0; j < exp_len; j++)
			{
				if(expect[j] != compare[ (j+i) % UART_RX_BUFF_SIZE ] && expect[j] != '*' ) //compare other chatacters
				{
					equal = 0;
					break;
				}
			}
			if(equal == 1)
			{
				match_position = i;
				//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
				return i;
			}
		}
	}
	//buff->start = (buff->start + cmp_len) % UART_RX_BUFF_SIZE;
	match_position = 0;
	return -1;
}

int32_t findMatchWild(uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, uint32_t timeout )
{
	int32_t match = -1;
	uint8_t match_position;

	uint32_t tickstart = 0x00U;
	tickstart = HAL_GetTick();

	do
	{

			if(buff->new_line_flag)
			{
				buff->new_line_flag = 0;
				/*
				uint8_t size = buffGetUsedSize();
				uint8_t data[size];
				for( uint8_t i = 0; i < size; i++)
					data[i] = buffRead();

				HAL_UART_Transmit( &huart2, data , size, 1000);
				*/



				//HAL_UART_Transmit( &huart2, "Rx captured\n" , strlen("Rx captured\n"), 1000);
			}
			match =  compareResponseWild(buff, expect, exp_len, &buff->data[buff->start], uartRxBuffGetUsedSize( buff ), &match_position);
			if(match == 1)
			{
				//HAL_UART_Transmit( &huart2, "match!\n" , strlen("match!\n"), 1000);
				match = buff->start;
				break;
			}


	}
	//while(1);
	while( (HAL_GetTick() - tickstart) < timeout );

	//buff->start = (buff->start + buffGetUsedSize()) % UART_RX_BUFF_SIZE;
	return match;
}

int32_t findMatchNonblocking(uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, uint32_t timeout )
{
	int32_t match = -1;
	uint8_t match_position;

	uint32_t tickstart = 0x00U;
	tickstart = HAL_GetTick();

	do
	{


			if(buff->new_line_flag)
			{
				buff->new_line_flag = 0;
				/*
				uint8_t size = buffGetUsedSize();
				uint8_t data[size];
				for( uint8_t i = 0; i < size; i++)
					data[i] = buffRead();

				HAL_UART_Transmit( &huart2, data , size, 1000);
				*/



				//HAL_UART_Transmit( &huart2, "Rx captured\n" , strlen("Rx captured\n"), 1000);
			}
			match =  compareResponse(buff, expect, exp_len, &buff->data[buff->start], uartRxBuffGetUsedSize( buff ), &match_position);
			if(match != -1)
			{
				//HAL_UART_Transmit( &huart2, "match!\n" , strlen("match!\n"), 1000);
				match = buff->start;
				break;
			}


	}
	//while(1);
	while( (HAL_GetTick() - tickstart) < timeout );

	//buff->start = (buff->start + buffGetUsedSize()) % UART_RX_BUFF_SIZE;
	return match;
}

uint8_t findMatchAndValueBlocking(uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, int32_t * value, uint8_t value_start, uint8_t value_len, uint8_t value_format)
// returns true if match, value contains numeric value
// else returns false, value = 0
{


		while(buff->new_line_flag)
		{
			//HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_SLEEPENTRY_WFI);
		}



	uint8_t match_position;
	uint8_t match = compareResponse(buff, expect, exp_len, &buff->data[buff->start], uartRxBuffGetUsedSize( buff ), &match_position);
	if( match )
	{
		/*
		HAL_UART_Transmit( &huart2, "Match found. Position:", strlen("Match found. Position:"), 1000 );
		char string[5];
		get_dec_str(&string, 5, match_position);
		HAL_UART_Transmit( &huart2, string, 5, 1000 );
		HAL_UART_Transmit( &huart2, "\n", strlen("\n"), 1000 );
		*/
		// parse value starting at match position according to format
		uint8_t start_old = buff->start;
		buff->start = (buff->start + value_start + match_position ) % UART_RX_BUFF_SIZE;

		uint8_t val_str[20];
		for( int i = 0; i  <value_len; i++)
		{
			val_str[i] = buffRead( buff );
		}

		int32_t dec = strToDec( val_str, value_len);
		buff->start = (start_old + uartRxBuffGetUsedSize( buff ) ) % UART_RX_BUFF_SIZE;
		* value = dec;
	}
	else
	{	value = 0;
		buff->start = (buff->start + uartRxBuffGetUsedSize( buff ) ) % UART_RX_BUFF_SIZE;
	}
	return match;

}
