/*
 * uartRxBuff.h
 *
 *  Created on: May 25, 2017
 *      Author: fiala
 */

#ifndef UARTRXBUFF1100_H_
#define UARTRXBUFF1100_H_


#include "stdint.h"
#include "usart.h"


#define UART_RX_BUFF_SIZE 200

struct uartRxBuff_t
{
	uint8_t data[UART_RX_BUFF_SIZE];
	uint16_t start;
	uint16_t end;
	uint8_t new_line_flag;
};
typedef struct uartRxBuff_t uartRxBuff_t;

uartRxBuff_t huart1buffer;
uartRxBuff_t huart2buffer;

char uart1buffer[ 2 ];
char uart2buffer[ 2 ];

void uartRxBuffInit(uartRxBuff_t * buff);
void uartRxBuffWrite(uartRxBuff_t * buff, uint8_t data);
uint8_t uartRxBuffRead(uartRxBuff_t * buff);
uint8_t uartRxBuffGetUsedSize( uartRxBuff_t * buff);
int32_t compareResponse( uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, uint8_t * compare, uint8_t cmp_len, uint8_t * match_position );
int32_t findMatchNonblocking( uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, uint32_t timeout );
int32_t copyFromBuffer( uartRxBuff_t * buff, uint8_t size, int32_t position, uint8_t * output) ;
uint8_t findMatchAndValueBlocking( uartRxBuff_t * buff, uint8_t * expect, uint8_t exp_len, int32_t * value, uint8_t value_start, uint8_t value_len, uint8_t value_format);
#endif /* UARTRXBUFF_H_ */
